package org.zeroturnaround.javarebel.integration.spring.cbp;

import org.zeroturnaround.bundled.javassist.CtNewMethod;

import org.zeroturnaround.bundled.javassist.CtMethod;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;

import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Scans the classpath for new components.
 * 
 * @author Jevgeni Kabanov
 */
public class ComponentScanBeanDefinitionParserCBP extends
    JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass)
      throws Exception {
    
    CtMethod parseMethod = ctClass.getDeclaredMethod("parse");
    CtMethod reparseMethod = CtNewMethod.copy(parseMethod, "reparse", ctClass, null);
    ctClass.addMethod(reparseMethod);
    parseMethod.setBody("{org.zeroturnaround.javarebel.integration.spring.AnnotationBeanDefinitionManager.registerComponentScanner($0, $1, $2); " +
    		"return reparse($1,$2);}");
  }
}
