package org.zeroturnaround.javarebel.integration.spring.cbp;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Removes the bean definition to prevent overriding messages 
 * and duplicate exceptions.
 */
public class DefaultListableBeanFactoryCBP extends JavassistClassBytecodeProcessor {
  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    CtMethod m = ctClass.getDeclaredMethod("registerBeanDefinition");   
    m.insertBefore("beanDefinitionMap.remove($1);");
  }
}
