package org.zeroturnaround.javarebel.integration.spring.cbp;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Avoids error "Duplicate &lt;global-method-security&gt; detected" during a
 * reload of Spring Security bean definitions.
 */
public class GlobalMethodSecurityBeanDefinitionParserCBP extends
        JavassistClassBytecodeProcessor {
    public void process(ClassPool cp, ClassLoader cl, CtClass ctClass)
            throws Exception {
        CtMethod m =
                ctClass.getDeclaredMethod(
                        "registerDelegatingMethodDefinitionSource");
        m.insertBefore(
                "if ($1.getRegistry().containsBeanDefinition(org.springframework.security.config.BeanIds.DELEGATING_METHOD_DEFINITION_SOURCE)) { $1.getRegistry().removeBeanDefinition(org.springframework.security.config.BeanIds.DELEGATING_METHOD_DEFINITION_SOURCE); }");                                         
    }
}
