package org.zeroturnaround.javarebel.integration.spring.cbp;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Avoids error "Duplicate &lt;http&gt; element detected" during a reload of
 * Spring Security bean definitions.
 */
public class HttpSecurityBeanDefinitionParserCBP
        extends JavassistClassBytecodeProcessor {
    public void process(ClassPool cp, ClassLoader cl, CtClass ctClass)
            throws Exception {
        CtMethod m =
                ctClass.getDeclaredMethod(
                        "registerFilterChainProxy");
        m.insertBefore(
                "if ($1.getRegistry().containsBeanDefinition(org.springframework.security.config.BeanIds.FILTER_CHAIN_PROXY)) { $1.getRegistry().removeBeanDefinition(org.springframework.security.config.BeanIds.FILTER_CHAIN_PROXY); }");
    }

}
