package org.zeroturnaround.javarebel.integration.spring.cbp;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtConstructor;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Disables Spring annotation cache for dependency method and field annotations.
 */
public class InjectionMetadataCacheCBP extends JavassistClassBytecodeProcessor {

	public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    CtConstructor[] ctrs = ctClass.getConstructors();
    for (int i = 0; i < ctrs.length; i++) {
      ctrs[i].insertAfter(
          "injectionMetadataCache = new org.zeroturnaround.javarebel.integration.spring.NopMap();");      
    }
	}
}
