package org.zeroturnaround.javarebel.integration.spring.cbp;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Registers each XML bean resource with the SpringBeanReloader.
 */
public class XmlBeanDefinitionReaderCBP extends JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    CtMethod m = ctClass.getMethod("loadBeanDefinitions", "(Lorg/springframework/core/io/Resource;)I");   
    m.insertBefore("org.zeroturnaround.javarebel.integration.spring.XmlBeanDefinitionManager" +
    		             ".registerXmlResource($0, $1);");
  }
}
